#include <stdio.h>
#include <stdlib.h>
#include <math.h>
int main()
{
    int W, H, Q, R, operacija;
    scanf("%d %d %d %d", &W, &H, &R, &Q);
    double ispis[Q];
    double visina[W+1];
    for(int i=0;i<W+1;i++)
    {
        visina[i]=H;
    }
    for(int i=0;i<Q;i++)
    {
        scanf("%d", &operacija);
        if(operacija==1)
        {
            int x, y;
            scanf("%d %d", &x , &y);
            for(int j=1;j<W+1;j++)
            {
                if(x==j)
                {
                    visina[j]=y-visina[j];
                }
                else if(x>j)
                {
                    
                }
                else /// x<j
                {
                    
                }
            }
        }
        else
        {
            int tacka;
            scanf("%d", &tacka);
            ispis[i]=visina[tacka];
        }
    }
    for(int i=0;i<Q;i++)
    {
        printf("%lf\n", ispis[i]);
    }
    return 0;
}